NB. begin_simple_server_or_client_jconsole.ijs
NB. begin_simple_server_or_client_jconsole_2023_10_13_making_basic.ijs

NB. By Yuji Suda
NB. g.ysuda@gmail.com

NB. -------------------------
NB. --- some system tools ---
NB. -------------------------

NB. ====================================================================================================
NB. screen output, argument should be string
screen_out =: 3 : 0
y 1!:2 >2
)

NB. ====================================================================================================
NB. alternative definition
print =: screen_out

NB. ====================================================================================================
NB. pwd print working directory
pwd =: 3 : 0
1!:43 ''
)

NB. ====================================================================================================
NB.  change directory
cddir =: 3 : 0
1!:44 y
)

NB. ====================================================================================================
NB. alternative definition
change_dir =: cddir
cdir =: cddir

NB. ====================================================================================================
NB. keyboard input string
keyin =: 3 : 0
1!:1 <1
)

NB. ====================================================================================================
NB. scroll screen by arg number of lines
scroll_up_screen =: 3 : 0
rep =. 0
while. rep<y do.
  print CRLF
  rep =. rep + 1
end.
)

NB. ---------------
NB. --- globals ---
NB. ---------------

WINDOWS_HOME_DIR   =: 'c:'

SOURCE_DIRECTORY   =: '/making_basic/jconsole/jsocket'

NB. ------------------------
NB. --- support function ---
NB. ------------------------

NB. ====================================================================================================
NB. change directory with reconfirmation
NB. argument is desired working directory in string
change_working_directory =: 3 : 0
  cdir y
  print CRLF
  print 'working directory is set at ', y
  a_confirmation =. pwd 0
  print 'pwd command returns:        ', a_confirmation
  print CRLF
1
)

NB. --------------------
NB. ---  main script ---
NB. --------------------

NB. ====================================================================================================
NB. main script to begin server or client in a given OS
NB. argument y is either 'server' or 'client', otherwise function aborts
begin_jsocket_simple_server_or_client_in_jconsole =: 3 : 0

begin_option =. ":y

NB. parse begin option
option_status =. 0

if. begin_option -: 'server' do.
          print 'option is server'
          option_status =. 1
end.
if. begin_option -: 'client' do.
          print 'option is client'
          option_status =. 1
end.
if. option_status = 0 do.
          print 'option is inappropriate!'
end.

NB. check option_status, abort if with an error
if. option_status = 0 do.
  print 'specified argument ', begin_option, ' has an error.'
  print 'it should be either ', '''', 'server', '''', ' or ', '''',  'client', ''''
  1
  return.
end.

NB. check current OS
CURRENT_OS =: 9!:12'' NB. 9!:12 '' returns current os  5: mac/unx/linux    6:windows

NB. change directory to current OS specific working directory
if. CURRENT_OS = 6 do.
    print '   your OS is windows'
    a_working_directory =. WINDOWS_HOME_DIR, SOURCE_DIRECTORY
    change_working_directory a_working_directory
end.

if. CURRENT_OS = 5 do.
    print '   your OS is mac/unix'
    MAC_LINUX_HOME_DIR =: _1}.2!:0 'echo $HOME'
    a_working_directory =. MAC_LINUX_HOME_DIR, SOURCE_DIRECTORY
    change_working_directory a_working_directory
end.

NB. reconfirmation of working directory
a_selected_dir =. pwd 0
print 'working directory confirmation = ', a_selected_dir

NB. load specified application script stored in working directory
if. begin_option -: 'server' do.
    load 'jsocket_simple_server_jconsole.ijs'
    ". 'start_simple_server 0'
end.
if. begin_option -: 'client' do.
    load 'jsocket_simple_client_jconsole.ijs'
    ". 'start_simple_client 0'
end.
1
)

NB. ====================================================================================================
NB. alternative definition
begin =: begin_jsocket_simple_server_or_client_in_jconsole

NB. ====================================================================================================
NB. execute the following on loading
scroll_up_screen 50
print '   please type either of the following commands and hit enter to begin each  menu'
print '   begin ','''', 'server', ''''
print '   or'
print '   begin ','''', 'client', ''''
