NB. jsocket_simple_client_jconsole.ijs
NB. jsocket_simple_client_jconsole_2023_09_05.ijs

NB. Yuji Suda
NB. g.ysuda@gmail.com
NB. encoding code: UTF-8

NB. The socket communication of this application is based on
NB. J's Studio->Labs->Socket Driver Server and Socket Driver - Client

NB. This application is for jconsole.exe (windows) and jconsole (mac and linux).
NB. The script is valid for qt terminal but it may fail to display messages during
NB. the operation.

NB. See. https://code.jsoftware.com/wiki/Guides/Asynchronous_GUI#J_Processing

NB. Initially, screen output messages were written in Japnaese, but finally
NB. screen out messages have been written in English in order to avoid mismatching
NB. in the encoding code of Japanese windows jconsole.exe to jconsoles of mac and linux.

NB. Encoding-code for jconsole.exe in Japanese windows is shift-JIS, whereas
NB. the code is UTF-8 in mac and linux jconsole.

NB. There are remaining commented out Japnaese messages for convenience.

NB. ====================================================================================================
NB. load drivers for socket 
load 'socket'
coinsert 'jsocket'

NB. -------------------------
NB. --- some system tools ---
NB. -------------------------

NB. ====================================================================================================
NB. keyboard input string
keyin =: 3 : 0
1!:1 <1
)

NB. ====================================================================================================
NB.screen output
screen_out =: 3 : 0
y 1!:2 >2
)

NB. ====================================================================================================
NB. alternative definition
print =: screen_out

NB. ====================================================================================================
NB. scroll screen by arg mumber of lines
scroll_up_screen =: 3 : 0
rep =. 0
while. rep<y do.
  print CRLF
  rep =. rep + 1
end.
)

NB. ====================================================================================================
NB. write string to a file
write_str_to_file =: 4 : 0
x 1!:2 <y
)

NB. ====================================================================================================
NB. alternative definition
wtf =: write_str_to_file

NB. ====================================================================================================
NB. append string to a file
append_it =: 4 : 0
x 1!:3 <y
)

NB. -------------------------
NB. --- support finctions ---
NB. -------------------------

NB. ====================================================================================================
NB. intialization of IP and Port number for connection
initialize_ip_and_port =: 3 : 0
HOST_PORT =: '1500'
HOST_IP =: '127.0.0.1'
HOST_PORT; HOST_IP
)

NB. ====================================================================================================
NB. display client job menu
disp_client_terminal_menu =: 3 : 0
scroll_up_screen 20
print ''
print ''
print ''
print ' ======= jsocket simple client menu (ver 0.1) ======='
print ''
        connect_condition =. ' current host IP = '
        connect_condition =. connect_condition, HOST_IP
        connect_condition =. connect_condition, '  PORT = '
        connect_condition =. connect_condition, HOST_PORT 
print   connect_condition
print ''
print ' 1 change HOST IP address'
print ' 2 change port number'
print ' C connect to server'
print ' Q quit menu'
print ''
print ' input your selection 1, 2, C or Q'
1
)

NB. ====================================================================================================
NB. one keyin charactor selection of menu commands
one_chr_menu_selection =: 3 : 0  NB. this does work
your_chr =. y  NB. take from argument
a_value =. a. i. your_chr
b_value =. ":a_value
select. ".b_value
case. (a. i. '1') do.
  COMMAND_NAME =: 'change_target_host_IP'
case. (a. i. '2') do.
  COMMAND_NAME =: 'change_target_host_port'
case. (a. i. 'C') do.
  COMMAND_NAME =: 'execute_connection'
case. (a. i. 'c') do.
  COMMAND_NAME =: 'execute_connection'
case. (a. i. 'Q') do.
  COMMAND_NAME =: 'exit_menu'
case. (a. i. 'q') do.
  COMMAND_NAME =: 'exit_menu'
case. (a. i. 'A') do.
case.  do.
  COMMAND_NAME =: ''
end.
1
)

NB. ====================================================================================================
NB. assign new host IP address
change_target_host_IP =: 3 : 0
   print CRLF, 'please input HOST IP address'
NB.print CRLF, 'ホストIPアドレスを入力して下さい'
   a_new_IP =. keyin 8
   HOST_IP =: a_new_IP
1
)

NB. ====================================================================================================
NB. assign new host port number
change_target_host_port =: 3 : 0
   print CRLF, 'please input port number'
NB.print CRLF, '使用するポート番号を入力して下さい'
   a_new_port =. keyin 8
   HOST_PORT =: a_new_port
1
)

NB. ====================================================================================================
NB. recieve message from the server
rec_msg =: 3 : 0
r =. sdrecv SKCLIENT, REC_BUF_SIZE_FOR_TERM, 0
er =. sderror c=. >{.r
rec_data =. >1{r

NB. エラーコードがソケット回線切断の場合、切断のイベントを通知
if. (er -:'ECONNRESET') do.
       NB. print '通信切断がありました '
       NB. rec_data =. '通信切断がありました '
           rec_data =. 'communication has been disconnected '
end.
rec_data
)

NB. ====================================================================================================
NB. actural job of server connection
jsocket_client_terminal =: 3 : 0

sdcleanup ''

target_host_address =. 2;HOST_IP
target_port =. ".HOST_PORT NB.

REC_BUF_SIZE_FOR_TERM =: 100000 NB. default is 100Kbyte

NB. print CRLF, '', HOST_PORT, ' への接続を試みます'
    print CRLF, 'access to host: ', >1{target_host_address

print 'at the port:    ', ":target_port

SKCLIENT =: 0 pick sdcheck sdsocket ''

MY_Target_host_address =: sdcheck sdgethostbyname 'localhost' 

a_connect_status =. sdcheck sdconnect SKCLIENT; target_host_address, <target_port

NB. print 'socket sdconnect status: ', (":$a_connect_status), CRLF

connect_flg =. 0
if. (a_connect_status = 0) do.
    NB. print '$a_connect_status is zero'
    connect_flg =. 1
end. 

if. connect_flg = 1 do.
   NB. go in  infinite send/rec loop
   NB. if send msg is quit, then server stops

       print CRLF, 'now connected to server. you can input one line command'
   NB. print CRLF, 'サーバーと接続しました。一行 の入力が可能です'
       print 'input quit for disconnect communication or input halt to stop server operation.', CRLF
   NB. print '通信を終了するコマンドは quit です。サーバーを停止する場合は halt です。', CRLF

  while. 1 do.
    your_msg =. keyin 8
    if. your_msg -: 'halt' do.
      NB. send halt and break.
      your_msg_cmd =. your_msg
      sdcheck your_msg_cmd sdsend SKCLIENT, 0
      break.
    end.
    if. your_msg -: 'quit' do.
      your_msg_cmd =. your_msg
      sdcheck your_msg_cmd sdsend SKCLIENT, 0
      print 'terminate requiest: ', your_msg_cmd
      print 'communication is terminated.'
      print 'enter key to break'
      dummy =. keyin 8
      break.
    else.
      your_msg_cmd =. your_msg
      sdcheck your_msg_cmd sdsend SKCLIENT, 0
      NB. wait for in coming server reply (blocking...)
      print rec_msg 0 NB. msg recv function is blooking function
    end.
  end.
else.
   print CRLF, 'connection failure occured'
NB.print CRLF, 'サーバーと接続できませんでした。'
end.
sdcleanup ''
1
)

NB. ====================================================================================================
NB. alternative definition
execute_connection =: jsocket_client_terminal

NB. ------------------------------
NB. --- main script for client ---
NB. ------------------------------

NB. ====================================================================================================
jsocket_simple_client_menu =: 3 : 0
initialize_ip_and_port 0
while. 1 do.
    disp_client_terminal_menu 0
    your_cmd =. keyin 8
    one_chr_menu_selection your_cmd

        print CRLF,'your selection is ', COMMAND_NAME
    NB. print CRLF,'選択されたコマンドは ', COMMAND_NAME, ' です'
    NB. print CRLF,'enter key で次に進みます'
    NB. dummy =. keyin 8

    if. COMMAND_NAME -: 'exit_menu' do.
       break.  NB. exit from this function
    else.
       try.
          NB. execute COMMAND_NAME
          a_cmd =. COMMAND_NAME, ' 0'
          ". a_cmd
       catch.
              print 'connection failure occured. please check whether the server is running'
          NB. print 'サーバーと接続できませんでした。サーバーの起動を確認してください。'
	      print 'enter key to go back to menu'
          NB. print 'enter key でメニューに戻ります'
	      dummy =. keyin 8
       end.
    end.
end.
    print 'now exited from client menu'
NB. print 'ターミナル管理メニューを終了しました。'

sdcleanup ''
print 'type in ',CRLF, 'start_simple_client 0 to resume'
print '   start_simple_client 0 or'
print '   ssc 0'
1
)

NB. ====================================================================================================
NB. alternative definition
start_simple_client =: jsocket_simple_client_menu
ssc                 =: jsocket_simple_client_menu

NB. ====================================================================================================
NB. print the following message on loading
print 'type in ',CRLF, 'start_simple_client 0 to begin'
print '   start_simple_client 0 or'
print '   ssc 0'
